********************************************************************************

	global R_FAK 		= 2		// Rate of Return on Fixed Assets Capital	
	global R_INK 		= 1		// Rate of Return on Inventories Capital	
	global sigma 		= 4		// Elasticity of Substitution
	global sigmatrim 	= 4		// Sigma to use when trimming TFPQ

	set type double		
	
	// Define Programs
	do ${misalloccode}/${sub}/calcAE	// defines the program, change path as needed
	do ${misalloccode}/${sub}/calcAE_ln	// defines the program, change path as needed

********************************************************************************

	**********************************************
	* CONSTRUCT AGGREGATE ALLOCATIVE EFFICIENCY: *
	**********************************************
	
	// Full formula for allocative efficiency
	
	use ${madeASI}/trimmedASI, clear	// change path as needed
			
	gen Asi 	= Qsi ^ (${sigma} / (${sigma} - 1) ) 	/ ((Ksi^alpha_s * wLsi ^(1-alpha_s))^gamma_s * Xsi^(1 - gamma_s))	
	gen TFPRsi 	= Qsi 									/ ((Ksi^alpha_s * wLsi ^(1-alpha_s))^gamma_s * Xsi^(1 - gamma_s))
	gen ARPLsi	= (${sigma} - 1)/ ${sigma} * (1 - alpha_s) * gamma_s 	* Qsi / wLsi
	gen ARPKsi	= (${sigma} - 1)/ ${sigma} * alpha_s * gamma_s 			* Qsi / Ksi
	gen ARPXsi	= (${sigma} - 1)/ ${sigma} * (1 - gamma_s)	 			* Qsi / Xsi
			
	calcAE ARPLsi ARPKsi ARPXsi Asi TFPRsi Qsi mult alpha_s gamma_s theta_s		// use calcAE_ln for allocative efficiency formula under lognormal disribution of A and tau
						
	
	
	
	
	
	
