
* Original Date of Creation: August 30th 2016
* Last Updated: July 2019
* Updated by: Cian

* Comments and Issues:
* 	- 


program define calcAE

	local ARPLsi 	"`1'"
	local ARPKsi 	"`2'"
	local ARPXsi 	"`3'"
	local Asi 		"`4'"
	local TFPRsi 	"`5'"
	local Qsi 		"`6'"	
	local mult 		"`7'"		
	local alpha_s 	"`8'"		
	local gamma_s 	"`9'"		
	local theta_s 	"`10'"
	
	/*
	local ARPLsi 	"ARPLsi"
	local ARPKsi 	"ARPKsi"
	local ARPXsi 	"ARPXsi"
	local Asi 		"Asi"
	local TFPRsi 	"TFPRsi"
	local Qsi 		"Qsi"	
	local mult 		"Tmult"		
	local alpha_s 	"Talpha_sy"		
	local gamma_s 	"Tgamma_sy"		
	local theta_s 	"Ttheta_sy"	
	*/

	bysort s year: egen mult_s 			= total(`mult')
	bysort s year: egen PQ_s 			= total(`mult' * `Qsi')		
	bysort s year: egen ARPLbar_temp 	= total(`mult' * `Qsi' / PQ_s * (1 / `ARPLsi'))
	bysort s year: egen ARPKbar_temp 	= total(`mult' * `Qsi' / PQ_s * (1 / `ARPKsi'))
	bysort s year: egen ARPXbar_temp 	= total(`mult' * `Qsi' / PQ_s * (1 / `ARPXsi'))

	gen ARPLbar_s 		= 1 / ARPLbar_temp
	gen ARPKbar_s 		= 1 / ARPKbar_temp
	gen ARPXbar_s 		= 1 / ARPXbar_temp
	
	gen TFPRbar_s = (${sigma} / (${sigma} - 1)) * (ARPLbar_s / ((1 - `alpha_s')*`gamma_s') )^((1 - `alpha_s')*`gamma_s') * ///
												(ARPKbar_s / (`alpha_s' * `gamma_s'))^(`alpha_s' * `gamma_s') * ///
												(ARPXbar_s / (1 - `gamma_s'))^(1 - `gamma_s')
									
	bysort s year: egen Atilde_s_temp = total(`mult' / mult_s * `Asi'^(${sigma} - 1))
	gen Atilde_s = Atilde_s_temp^(1 / (${sigma} - 1))

	bysort s year: egen lAbar_s_temp = total(`mult' / mult_s * ln(`Asi'))
	gen Abar_s = exp(lAbar_s_temp)
	
	gen rtau_si 		= TFPRbar_s / `TFPRsi'
	gen rA_si 			= `Asi'	 	/ Atilde_s

	bysort s year: egen AE_s_temp = total( `mult' / mult_s * (rA_si * rtau_si)^(${sigma} - 1) )
	gen AE_s = AE_s_temp^(1 / (${sigma} - 1))
	
	gen PD_s = Atilde_s / Abar_s
	
	********************************************************************************	// Calculate Aggregate Allocative Efficiency

	bysort year: gen Nobs = _N

	collapse (mean) `gamma_s' `theta_s' AE_s PD_s Nobs, by(s year)

	tsset s year, yearly 
	sort s year

	bysort year: egen gammatheta_s 	= total(`gamma_s' * `theta_s')
	bysort year: egen lAE 			= total(`theta_s' / gammatheta_s  	* log(AE_s))
	bysort year: egen lPD 			= total(`theta_s' / gammatheta_s  	* log(PD_s))

	collapse (mean) lAE lPD Nobs (count) Ns = s, by(year)
										
	tsset year, yearly
	sort year

	gen AE 				= exp(lAE)
	gen PD 				= exp(lPD)
	gen pctAEgains 		= (1 / AE - 1) 		* 100

	keep year AE pctAEgains PD Nobs Ns
	sort year

	compress

end

