
* Original Date of Creation: August 30th 2016
* Last Updated: July 2019
* Updated by: Cian

* Comments and Issues:
* 	- 


program define calcAE_ln

	local ARPLsi 	"`1'"
	local ARPKsi 	"`2'"
	local ARPXsi 	"`3'"
	local TFPRsi 	"`4'"
	local mult 		"`5'"		
	local alpha_s 	"`6'"		
	local gamma_s 	"`7'"		
	local theta_s 	"`8'"
	
	bysort s year: egen tot`mult' = total(`mult')
	bysort s year: egen lTFPRs 	= total( log(`TFPRsi') * `mult' / tot`mult')
	bysort s year: egen lARPLs 	= total( log(`ARPLsi') * `mult' / tot`mult')
	bysort s year: egen lARPKs 	= total( log(`ARPKsi') * `mult' / tot`mult')
	bysort s year: egen lARPXs 	= total( log(`ARPXsi') * `mult' / tot`mult')

	bysort s year: egen vlTFPRs 	= total( (log(`TFPRsi') - lTFPRs)^2 * `mult' / tot`mult')
	bysort s year: egen vlARPLs 	= total( (log(`ARPLsi') - lARPLs)^2 * `mult' / tot`mult')
	bysort s year: egen vlARPKs 	= total( (log(`ARPKsi') - lARPKs)^2 * `mult' / tot`mult')
	bysort s year: egen vlARPXs 	= total( (log(`ARPXsi') - lARPXs)^2 * `mult' / tot`mult')

	
	gen lAE_s = -(${sigma} - 1) / 2 				* 	vlTFPRs 	///
					- 1/2 * (1 - `alpha_s') * `gamma_s' * 	vlARPLs 	///
					- 1/2 * `alpha_s' * `gamma_s' 		* 	vlARPKs 	///
					- 1/2 * (1 - `gamma_s') 			* 	vlARPXs
					
	gen AE_s = exp(lAE_s)
	
	
	********************************************************************************	// Calculate Aggregate Allocative Efficiency

	gen Nobs = _N

	collapse (mean) `gamma_s' `theta_s' AE_s Nobs, by(s year)

	tsset s year, yearly 
	sort s year

	bysort year: egen gammatheta 	= total(`gamma_s' * `theta_s')
	bysort year: egen lAE 			= total(`theta_s' / gammatheta  	* log(AE_s))

	collapse (mean) lAE Nobs (count) Ns = s, by(year)
										
	tsset year, yearly
	sort year

	gen AE 				= exp(lAE)
	gen pctAEgains 		= (1 / AE - 1) 		* 100

	keep year AE pctAEgains Nobs Ns
	sort year

	compress

end

